'// Arguments:
' /excl:"<excl1;excl2> - lists of exclusions
' /diff:<path_to_diffFile> - diffFile
' /drop - remove filtered nodes

Option Explicit

Dim shell, xmldoc, element(1), rx_key, rx_dir, rx_file, rx_value, rootnode, RegEx, str, bDrop

If WScript.Arguments.Named.Exists("drop") Then
	bDrop = True
Else
	bDrop = False
End If

Set shell = CreateObject("WScript.Shell")
Set xmldoc = CreateObject("Msxml2.Domdocument")
Set RegEx = New RegExp

ReDim rx_key(-1)
ReDim rx_dir(-1)
ReDim rx_file(-1)
ReDim rx_value(-1)


Dim exclFile
For Each exclFile In Split(WScript.Arguments.Named("excl"),";")
	xmldoc.load exclFile
	getExclusions rx_file,"file"
	getExclusions rx_value,"value"
	getExclusions rx_key,"key"
	getExclusions rx_dir,"dir"
Next




'// ================
'// Start processing
'// ================
xmldoc.load WScript.Arguments.Named("diff")

For Each rootnode In xmldoc.selectNodes("/diffFile/localdrives/dir")
	recurs rootnode.getAttribute("id"), rootnode
Next
For Each rootnode In xmldoc.selectNodes("/diffFile/registry/key")
	recurs rootnode.getAttribute("id"), rootnode
Next

xmldoc.save WScript.Arguments.Named("diff")

'//=========================================================================
Sub recurs(ByVal path, ByRef oNode)
	Dim node
	If oNode.baseName = "dir" Then
		For Each node In oNode.selectNodes("dir")
			If check(path & "\" & node.getAttribute("id"),rx_dir) Then
				'mark node
				If bDrop Then
					oNode.removeChild(node)
				Else
					node.setAttribute "incl", 0
				End If
			Else
				recurs path & "\" & node.getAttribute("id"), node
			End If
		Next
		For Each node In oNode.selectNodes("file")
			If check(path & "\" & node.getAttribute("id"),rx_file) Then
				If bDrop Then
					oNode.removeChild(node)
				Else
					node.setAttribute "incl", 0
				End If
			End If
		Next
	ElseIf oNode.baseName = "key" Then
		For Each node In oNode.selectNodes("key")
			If check(path & "\" & node.getAttribute("id"),rx_key) Then
				'mark node
				If bDrop Then
					oNode.removeChild(node)
				Else
					node.setAttribute "incl", 0
				End If
			Else
				recurs path & "\" & node.getAttribute("id"), node
			End If
		Next
		For Each node In oNode.selectNodes("value")
			If check(path & "\" & node.getAttribute("id"),rx_value) Then
				If bDrop Then
					oNode.removeChild(node)
				Else
					node.setAttribute "incl", 0
				End If
			End If
		Next
	End If
End Sub

'//=========================================================================
Function check(ByVal path, ByRef arr)
	Dim i
	check = False
	For Each i In arr
		If i(1) Then
			If i(0).Test(path) Then
				check = True
				Exit For
			End If
		Else
			If LCase(path) = i(0) Then
				check = True
				Exit For
			End If
		End If
	Next
End Function

'//=========================================================================
Sub getExclusions(ByRef arr, ByVal baseName)
	Dim node
	For Each node In xmldoc.selectNodes("//" & baseName)
		If LCase(node.getAttribute("type")) = "expand" Then
			element(0) = LCase(shell.ExpandEnvironmentStrings(node.text))
			element(1) = False
		ElseIf LCase(node.getAttribute("type")) = "regexp" Then
			Set RegEx = New RegExp
			RegEx.IgnoreCase = True
			RegEx.Pattern = node.text
			Set element(0) = RegEx
			element(1) = True
		Else
			element(0) = LCase(node.text)
			element(1) = False
		End If
		
		ReDim Preserve arr(UBound(arr)+1)
		arr(UBound(arr)) = element
	Next
End Sub
